#include <string>

using namespace std;

#include "Symbol.h"

Symbol::Symbol()
{
  m_link = NULL;
}


Symbol::Symbol(string name, double value)
{
  m_name = name;
  m_value = value;
  m_link = NULL;
}


Symtable::Symtable()
{
}

Symtable::~Symtable()
{
  for (int i = 0; i < N; i++) {
    Symbol *sym = m_head[i];
    while (sym != NULL) {
      Symbol *sym_next = sym->m_link;
      delete sym;
      sym = sym_next;
    }
  }
}

int Symtable::hashfun(const char *name) const
{
  int sum = 0;
  while (*name != 0) {
    sum = (sum << 2) ^ *name++;
  }
  return (sum % N);
}

Symbol *Symtable::find(string name, int &h) const
{
  Symbol *search;

  h = hashfun(name.c_str());

  for (search = m_head[h]; search != NULL; search = search->m_link) {
    if (name == search->m_name) {
      return search;
    }
  }
  return NULL;
}

bool Symtable::set(string name, double value)
{
  int h;
  Symbol *search = find(name, h);
  if (search == NULL) {
    search = new Symbol(name, value);
    search->m_link = m_head[h];
    m_head[h] = search;
  }
  search->m_value = value;
  return true;
}

bool Symtable::get(string name, double &value) const
{
  int h;
  Symbol *search = find(name, h);
  if (search == NULL) {
    return false;
  }
  value = search->m_value;
  return true;
}

